#ifndef EFL_UI_FOCUS_OBJECT_EO_HH
#define EFL_UI_FOCUS_OBJECT_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_focus_object.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace ui { namespace focus { 
struct Object;
} } } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::focus::Object> : ::std::true_type {}; } }
namespace efl { namespace ui { namespace focus { 
struct Object;
} } } 

namespace eo_cxx {
namespace efl { namespace ui { namespace focus { 
struct Object {
   ::efl::eolian::return_traits<Eina_Rectangle>::type focus_geometry_get() const;
   ::efl::eolian::return_traits<bool>::type focus_get() const;
   ::efl::eolian::return_traits<void>::type focus_set( ::efl::eolian::in_traits<bool>::type focus) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_FOCUS_OBJECT_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::ui::focus::Object() const;
   operator ::efl::ui::focus::Object&();
   operator ::efl::ui::focus::Object const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Object const > operator&() const { return {this}; }
   /// @endcond
};
} } } 
}
namespace efl { namespace ui { namespace focus { 
struct Object : ::efl::eo::concrete
{
   explicit Object( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Object(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Object(Object const& other) = default;
   Object(Object&& other) = default;
   Object& operator=(Object const& other) = default;
   Object& operator=(Object&& other) = default;
   Object()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Object( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Object(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<Eina_Rectangle>::type focus_geometry_get() const;
   ::efl::eolian::return_traits<bool>::type focus_get() const;
   ::efl::eolian::return_traits<void>::type focus_set( ::efl::eolian::in_traits<bool>::type focus) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_FOCUS_OBJECT_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct focus_changed_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_FOCUS_OBJECT_EVENT_FOCUS_CHANGED; }
      typedef bool parameter_type;
   } const focus_changed_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Object const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Object) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Object>::value, "");
} } } 
#endif
